package com.cesgroup.zw.codetable.query;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;
import java.util.Map;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementCreator;
import org.springframework.jdbc.support.GeneratedKeyHolder;
import org.springframework.jdbc.support.KeyHolder;

import com.cesgroup.zw.common.parse.query.ParseQuery;


public class ParseQueryDAOImpl extends JdbcTemplate  implements ParseQuery {
	
	public List<Map<String, Object>> queryForList(String sql) {
		return super.queryForList(sql);
	}

	public int insert(String sql, Object[] params) {
		return super.update(sql,params);
	}

	public int execute(String sql, Object[] params) {

		return super.update(sql,params);
	}

	public long insertAndGetKey(final String sql) {
		KeyHolder keyHolder = new GeneratedKeyHolder();  
	    super.update(new PreparedStatementCreator() {
			public PreparedStatement createPreparedStatement(Connection con)
					throws SQLException {
				PreparedStatement ps = con.prepareStatement(sql,Statement.RETURN_GENERATED_KEYS);
				return ps;
			}
	    }, keyHolder);  
		return keyHolder.getKey().longValue();
	}

	public long count(String sql, Object[] params) {
		return super.queryForObject(sql, params, Long.class);
	}
	
}
