package com.cesgroup.zw.spring.boot.autoconfigure;

import java.io.IOException;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.core.io.support.ResourcePatternResolver;

@ConfigurationProperties(prefix = CodeTableProperties.PREFIX)
public class CodeTableProperties {

	public static final String PREFIX = "codetable";

	private static final ResourcePatternResolver resourceResolver = new PathMatchingResourcePatternResolver();

	private String dbFileLocation;

	private String xmlFileLocation;

	private String enable;
	
	private String webEnable;

	public String getDbFileLocation() {
		return dbFileLocation;
	}


	public void setDbFileLocation(String dbFileLocation) {
		this.dbFileLocation = dbFileLocation;
	}


	public String getXmlFileLocation() {
		return xmlFileLocation;
	}


	public void setXmlFileLocation(String xmlFileLocation) {
		this.xmlFileLocation = xmlFileLocation;
	}


	public Resource[] getDbCodeFiles() {
		return getResources(dbFileLocation);
	}
	
	public Resource[] getXmlCodeFiles() {
		return getResources(xmlFileLocation);
	}
	
	private Resource[] getResources(String location) {

		if(null == location) {
			return new Resource[0];
		}
		try {

			return resourceResolver.getResources(location);

		} catch (IOException e) {

			return new Resource[0];

		}

	}


	public String getEnable() {
		return enable;
	}


	public void setEnable(String enable) {
		this.enable = enable;
	}


	public String getWebEnable() {
		return webEnable;
	}


	public void setWebEnable(String webEnable) {
		this.webEnable = webEnable;
	}
	
	

}
