package com.cesgroup.zw.common.parse;

import java.util.List;
import java.util.Map;
/**
 * 参数解析接口
 * @author Roger
 * @version 1.0.0
 */
public interface ParameterParse {
	
	/**
	 * 解析表达式中的内容
	 * @param expression 表达式
	 * @param context 解析的容器
	 * @param params 解析的参数源
	 * @return 解析后的结果
	 */
	public Object parse(String expression,Map<String,Object> context,Object[] params);
	
	/**
	 * 从表达式中取出要解析的参数名
	 * @param expression 表达式
	 * @return 解析的参数名集合
	 */
	public List<String> getParameterName(String expression);
	
	/**
	 * 解析器的类型
	 * @return OGNL解析器，WEB解析器，默认的解析器，业务字典解析器，环境变量解析器
	 */
	public Type getType();
	
	enum Type {
		
		OGNL,WEB,DEFAULT,CODE_TABLE,ENV;
		
	}
	
	public final String EMPTY_KEY = "EMPTY_KEY";
}
