package com.cesgroup.zw.common.parse;

import java.util.ArrayList;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import ognl.Ognl;

/**
 * 解析器中的共通类
 * @author Roger 
 * @version 1.0.0
 *
 */
public class Parse {
	
	protected Log logger = LogFactory.getLog(getClass());
	
	/**
	 * 解析数据
	 * @param expression 表达式
	 * @param context 数据容器
	 * @return 解析结果
	 */
	protected Object getValue(String expression,Object context) {
		
		try {
			return Ognl.getValue(expression, context);
		} catch (Exception e) {
			logger.debug("参数["+expression+"]从"+context+"转换有错", e);
		}
		return null;
		
	}
	
	/**
	 * 从表达式中取出要解析的参数名
	 * ${}中的变量名
	 * @param expression 表达式
	 * @return 解析的参数名集合
	 */
	public List<String> getParameterName(String expression){
		List<String> names = new ArrayList<String>();
		while(true) {
			int index = expression.indexOf("${");
			 if(index < 0){
				 break;
			 }
			names.add(expression.substring(index+2,expression.indexOf("}")));
			expression = expression.substring(expression.indexOf("}")+1,expression.length());
		}
		return names;
	}
	
	
}
