package com.cesgroup.zw.core.codetable;


import java.lang.reflect.Field;
import java.util.Comparator;


public abstract class FieldComparator<T> implements Comparator<T> {

    protected Class<T> clazz;

    protected Field field;

    protected String sortFieldName;

    protected Order order = Order.ASC;

    public FieldComparator(Class<T> clazz, String sortFieldName) {

        super();
        this.clazz = clazz;
        this.sortFieldName = sortFieldName;
        init();
    }

    public FieldComparator(Class<T> clazz, String sortFieldName, Order order) {

        super();
        this.clazz = clazz;
        this.sortFieldName = sortFieldName;
        this.order = order;
        init();
    }

    private void init() {

        try {
			field = clazz.getDeclaredField(sortFieldName);
		} catch (Exception e) {
			
		}
        field.setAccessible(true);

    }

}
