package com.cesgroup.core.codetable;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import com.cesgroup.zw.core.codetable.CodeTableCache;



public class CodeTableCacheTest {

	
	@Test
	public void codeTable() throws Exception {
		
		CodeTableCache XML_CODE_TABLE =  CodeTableCache.getInstance();
		List<String> list = new ArrayList<String>();
		list.add("/codetable/xml-code-table-value.xml");
		
		loadXmlData(list,XML_CODE_TABLE);
		
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR11"));	
		
		XML_CODE_TABLE =  CodeTableCache.getInstance();
		list = new ArrayList<String>();
		list.add("/codetable/xml-code-table-value1.xml");
		
		loadXmlData(list,XML_CODE_TABLE);
		
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR22"));	
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR33"));	
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR11"));	
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR"));
		
		XML_CODE_TABLE.reload("SITE_BAR33");
		
		System.out.println("TESt");
		System.out.println(XML_CODE_TABLE.getGroup("SITE_BAR"));
	}
	
	private void loadXmlData(List<String> list,CodeTableCache XML_CODE_TABLE) {
		
		InputStream[] xmlCodeInputStreams = new InputStream[list.size()];
		
		for(int i =0 ;i < list.size();i++) {
			xmlCodeInputStreams[i] = CodeTableCacheTest.class.getResourceAsStream(list.get(i));
		}
		XML_CODE_TABLE.setXmlCodeInputStreams(xmlCodeInputStreams);
		
		
		try {
			XML_CODE_TABLE.loadData();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	
	
	public void dbCodeTable() throws Exception {
		
		CodeTableCache XML_CODE_TABLE =  CodeTableCache.getInstance();
		
		List<String> list = new ArrayList<String>();
		
		list.add("/codetable/db-code-table-define.xml");
		
		loadDBData(list,XML_CODE_TABLE);
		
		System.out.println(XML_CODE_TABLE.getGroup("SEC_USER"));
	}
	
	
	private void loadDBData(List<String> list,CodeTableCache XML_CODE_TABLE) {
		
		InputStream[] dbCodeInputStreams = new InputStream[list.size()];
		
		for(int i =0 ;i < list.size();i++) {
			dbCodeInputStreams[i] = CodeTableCacheTest.class.getResourceAsStream(list.get(i));
		}
		XML_CODE_TABLE.setDbCodeInputStreams(dbCodeInputStreams);
		
		
		try {
			XML_CODE_TABLE.loadData();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
